Index: drivers/scsi/fd_mcs.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/fd_mcs.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/fd_mcs.c	22 Jul 2004 19:50:04 -0000	1.1
+++ drivers/scsi/fd_mcs.c	4 Aug 2004 01:29:34 -0000	1.2
@@ -28,7 +28,7 @@
  * Author: Rickard E. Faith, faith@cs.unc.edu
  * Copyright 1992, 1993, 1994, 1995, 1996 Rickard E. Faith
  *
- * $Id: fd_mcs.c,v 1.1 2004/07/22 19:50:04 joff Exp $
+ * $Id: fd_mcs.c,v 1.2 2004/08/04 01:29:34 joff Exp $
 
  * This program is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by the
Index: drivers/scsi/fdomain.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/fdomain.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/fdomain.c	22 Jul 2004 19:50:04 -0000	1.1
+++ drivers/scsi/fdomain.c	4 Aug 2004 01:29:34 -0000	1.2
@@ -296,7 +296,7 @@
 
 #include <linux/config.h>	/* for CONFIG_PCI */
   
-#define VERSION          "$Revision: 1.1 $"
+#define VERSION          "$Revision: 1.2 $"
 
 /* START OF USER DEFINABLE OPTIONS */
 
@@ -2046,7 +2046,9 @@
 
 MODULE_LICENSE("GPL");
 
+#ifndef PCMCIA
 /* Eventually this will go into an include file, but this will be later */
 static Scsi_Host_Template driver_template = FDOMAIN_16X0;
 
 #include "scsi_module.c"
+#endif
Index: drivers/scsi/fdomain.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/fdomain.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/fdomain.h	22 Jul 2004 19:50:04 -0000	1.1
+++ drivers/scsi/fdomain.h	4 Aug 2004 01:29:34 -0000	1.2
@@ -4,7 +4,7 @@
  * Author: Rickard E. Faith, faith@cs.unc.edu
  * Copyright 1992, 1993, 1994, 1995 Rickard E. Faith
  *
- * $Id: fdomain.h,v 1.1 2004/07/22 19:50:04 joff Exp $
+ * $Id: fdomain.h,v 1.2 2004/08/04 01:29:34 joff Exp $
 
  * This program is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by the
Index: drivers/scsi/g_NCR5380.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/g_NCR5380.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/g_NCR5380.c	22 Jul 2004 19:50:07 -0000	1.1
+++ drivers/scsi/g_NCR5380.c	4 Aug 2004 01:29:34 -0000	1.2
@@ -80,8 +80,8 @@
 
 /*
  * $Log: g_NCR5380.c,v $
- * Revision 1.1  2004/07/22 19:50:07  joff
- * Initial revision
+ * Revision 1.2  2004/08/04 01:29:34  joff
+ * merging 2.4.26-vrs1
  *
  */
 
@@ -336,7 +336,7 @@
 			if (dev->irq_resource[0].flags & IORESOURCE_IRQ)
 				overrides[count].irq = dev->irq_resource[0].start;
 			else
-				overrides[count].irq = IRQ_NONE;
+				overrides[count].irq = SCSI_IRQ_NONE;
 			if (dev->dma_resource[0].flags & IORESOURCE_DMA)
 				overrides[count].dma = dev->dma_resource[0].start;
 			else
@@ -433,19 +433,19 @@
 		else
 			instance->irq = NCR5380_probe_irq(instance, 0xffff);
 
-		if (instance->irq != IRQ_NONE)
+		if (instance->irq != SCSI_IRQ_NONE)
 			if (request_irq(instance->irq, do_generic_NCR5380_intr, SA_INTERRUPT, "NCR5380", NULL)) {
 				printk(KERN_WARNING "scsi%d : IRQ%d not free, interrupts disabled\n", instance->host_no, instance->irq);
-				instance->irq = IRQ_NONE;
+				instance->irq = SCSI_IRQ_NONE;
 			}
 
-		if (instance->irq == IRQ_NONE) {
+		if (instance->irq == SCSI_IRQ_NONE) {
 			printk(KERN_INFO "scsi%d : interrupts not enabled. for better interactive performance,\n", instance->host_no);
 			printk(KERN_INFO "scsi%d : please jumper the board for a free IRQ.\n", instance->host_no);
 		}
 
 		printk(KERN_INFO "scsi%d : at " STRVAL(NCR5380_map_name) " 0x%x", instance->host_no, (unsigned int) instance->NCR5380_instance_name);
-		if (instance->irq == IRQ_NONE)
+		if (instance->irq == SCSI_IRQ_NONE)
 			printk(" interrupts disabled");
 		else
 			printk(" irq %d", instance->irq);
@@ -492,7 +492,7 @@
 	release_mem_region(instance->NCR5380_instance_name, NCR5380_region_size);
 #endif
 
-	if (instance->irq != IRQ_NONE)
+	if (instance->irq != SCSI_IRQ_NONE)
 		free_irq(instance->irq, NULL);
 
 	return 0;
@@ -805,7 +805,7 @@
 	PRINTP("NO NCR53C400 driver extensions\n");
 #endif
 	PRINTP("Using %s mapping at %s 0x%lx, " ANDP STRVAL(NCR5380_map_config) ANDP STRVAL(NCR5380_map_name) ANDP scsi_ptr->NCR5380_instance_name);
-	if (scsi_ptr->irq == IRQ_NONE)
+	if (scsi_ptr->irq == SCSI_IRQ_NONE)
 		PRINTP("no interrupt\n");
 	else
 		PRINTP("on interrupt %d\n" ANDP scsi_ptr->irq);
Index: drivers/scsi/g_NCR5380.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/g_NCR5380.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/g_NCR5380.h	22 Jul 2004 19:50:07 -0000	1.1
+++ drivers/scsi/g_NCR5380.h	4 Aug 2004 01:29:34 -0000	1.2
@@ -27,8 +27,8 @@
 
 /*
  * $Log: g_NCR5380.h,v $
- * Revision 1.1  2004/07/22 19:50:07  joff
- * Initial revision
+ * Revision 1.2  2004/08/04 01:29:34  joff
+ * merging 2.4.26-vrs1
  *
  */
 
Index: drivers/scsi/gdth.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/gdth.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/gdth.c	22 Jul 2004 19:50:04 -0000	1.1
+++ drivers/scsi/gdth.c	4 Aug 2004 01:29:34 -0000	1.2
@@ -27,8 +27,8 @@
  * Tested with Linux 1.2.13, ..., 2.2.20, ..., 2.4.18                   *
  *                                                                      *
  * $Log: gdth.c,v $
- * Revision 1.1  2004/07/22 19:50:04  joff
- * Initial revision
+ * Revision 1.2  2004/08/04 01:29:34  joff
+ * merging 2.4.26-vrs1
  *
  * Revision 1.61  2002/10/03 09:35:22  boji
  * Fixed SCREENSERVICE intialisation in SMP cases.
@@ -251,7 +251,7 @@
  * Initial revision
  *
  ************************************************************************/
-#ident "$Id: gdth.c,v 1.1 2004/07/22 19:50:04 joff Exp $" 
+#ident "$Id: gdth.c,v 1.2 2004/08/04 01:29:34 joff Exp $" 
 
 /* All GDT Disk Array Controllers are fully supported by this driver.
  * This includes the PCI/EISA/ISA SCSI Disk Array Controllers and the
@@ -4032,6 +4032,8 @@
             break;
         if (gdth_search_isa(isa_bios)) {        /* controller found */
             shp = scsi_register(shtp,sizeof(gdth_ext_str));
+            if(shp == NULL)
+            	continue;
             ha = HADATA(shp);
             if (!gdth_init_isa(isa_bios,ha)) {
                 scsi_unregister(shp);
Index: drivers/scsi/gdth.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/gdth.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/gdth.h	22 Jul 2004 19:50:04 -0000	1.1
+++ drivers/scsi/gdth.h	4 Aug 2004 01:29:35 -0000	1.2
@@ -10,7 +10,7 @@
  *
  * <achim.leubner@intel.com>
  *
- * $Id: gdth.h,v 1.1 2004/07/22 19:50:04 joff Exp $
+ * $Id: gdth.h,v 1.2 2004/08/04 01:29:35 joff Exp $
  */
 
 #include <linux/version.h>
Index: drivers/scsi/gdth_ioctl.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/gdth_ioctl.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/gdth_ioctl.h	22 Jul 2004 19:50:04 -0000	1.1
+++ drivers/scsi/gdth_ioctl.h	4 Aug 2004 01:29:35 -0000	1.2
@@ -2,7 +2,7 @@
 #define _GDTH_IOCTL_H
 
 /* gdth_ioctl.h
- * $Id: gdth_ioctl.h,v 1.1 2004/07/22 19:50:04 joff Exp $
+ * $Id: gdth_ioctl.h,v 1.2 2004/08/04 01:29:35 joff Exp $
  */
 
 /* IOCTLs */
Index: drivers/scsi/gdth_proc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/gdth_proc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/gdth_proc.c	22 Jul 2004 19:50:02 -0000	1.1
+++ drivers/scsi/gdth_proc.c	4 Aug 2004 01:29:35 -0000	1.2
@@ -1,5 +1,5 @@
 /* gdth_proc.c 
- * $Id: gdth_proc.c,v 1.1 2004/07/22 19:50:02 joff Exp $
+ * $Id: gdth_proc.c,v 1.2 2004/08/04 01:29:35 joff Exp $
  */
 
 #include "gdth_ioctl.h"
Index: drivers/scsi/gdth_proc.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/gdth_proc.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/gdth_proc.h	22 Jul 2004 19:50:02 -0000	1.1
+++ drivers/scsi/gdth_proc.h	4 Aug 2004 01:29:35 -0000	1.2
@@ -2,7 +2,7 @@
 #define _GDTH_PROC_H
 
 /* gdth_proc.h 
- * $Id: gdth_proc.h,v 1.1 2004/07/22 19:50:02 joff Exp $
+ * $Id: gdth_proc.h,v 1.2 2004/08/04 01:29:35 joff Exp $
  */
 
 static int gdth_set_info(char *buffer,int length,int vh,int hanum,int busnum);
Index: drivers/scsi/gvp11.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/gvp11.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/gvp11.h	22 Jul 2004 19:50:05 -0000	1.1
+++ drivers/scsi/gvp11.h	4 Aug 2004 01:29:35 -0000	1.2
@@ -1,6 +1,6 @@
 #ifndef GVP11_H
 
-/* $Id: gvp11.h,v 1.1 2004/07/22 19:50:05 joff Exp $
+/* $Id: gvp11.h,v 1.2 2004/08/04 01:29:35 joff Exp $
  *
  * Header file for the GVP Series II SCSI controller for Linux
  *
Index: drivers/scsi/hosts.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/hosts.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/hosts.c	22 Jul 2004 19:50:06 -0000	1.1
+++ drivers/scsi/hosts.c	4 Aug 2004 01:29:35 -0000	1.2
@@ -41,7 +41,7 @@
 #include "hosts.h"
 
 /*
-static const char RCSid[] = "$Header: /cvsroot/ts-7200/dist/linux24/drivers/scsi/hosts.c,v 1.1 2004/07/22 19:50:06 joff Exp $";
+static const char RCSid[] = "$Header: /cvsroot/ts-7200/dist/linux24/drivers/scsi/hosts.c,v 1.2 2004/08/04 01:29:35 joff Exp $";
 */
 
 /*
Index: drivers/scsi/hosts.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/hosts.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/hosts.h	22 Jul 2004 19:50:06 -0000	1.1
+++ drivers/scsi/hosts.h	4 Aug 2004 01:29:35 -0000	1.2
@@ -22,7 +22,7 @@
 #define _HOSTS_H
 
 /*
-    $Header: /cvsroot/ts-7200/dist/linux24/drivers/scsi/hosts.h,v 1.1 2004/07/22 19:50:06 joff Exp $
+    $Header: /cvsroot/ts-7200/dist/linux24/drivers/scsi/hosts.h,v 1.2 2004/08/04 01:29:35 joff Exp $
 */
 
 #include <linux/config.h>
Index: drivers/scsi/ide-scsi.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/ide-scsi.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/ide-scsi.c	22 Jul 2004 19:50:01 -0000	1.1
+++ drivers/scsi/ide-scsi.c	4 Aug 2004 01:29:35 -0000	1.2
@@ -531,6 +531,8 @@
 	atapi_bcount_t bcount;
 	struct request *rq = pc->rq;
 
+	feature.all = 0;
+
 	/* Set the current packet command */
 	scsi->pc = pc;
 	/* We haven't transferred any data yet */
@@ -539,6 +541,7 @@
 	/* Request to transfer the entire buffer at once */
 	bcount.all = IDE_MIN(pc->request_transfer, 63 * 1024);
 
+
 	if (drive->using_dma && rq->bh) {
 		if (test_bit(PC_WRITING, &pc->flags))
 			feature.b.dma = !HWIF(drive)->ide_dma_write(drive);
@@ -1105,15 +1108,34 @@
 
 int idescsi_reset (Scsi_Cmnd *cmd, unsigned int resetflags)
 {
+	return SCSI_RESET_SNOOZE;
+
+#ifdef WORK_IN_PROGRESS
 	ide_drive_t *drive	= idescsi_drives[cmd->target];
 
-	/* We cannot reset the interface holding the lock. We can
-	   drop the lock here however */
+	/* At this point the state machine is running, that
+	   requires we are especially careful. Ideally we want
+	   to abort commands on timeout only if they hit the
+	   cable but thats harder */
+
+	DRIVER(drive)->abort(drive, "scsi reset");
+	if(HWGROUP(drive)->handler)
+		BUG();
+	
+	/* Ok the state machine is halted but make sure it
+	   doesn't restart too early */ 
 	   
-	spin_unlock(&io_request_lock);
-	(void) ide_do_reset(drive);
-	spin_lock(&io_request_lock);
+	HWGROUP(drive)->busy = 1;
+	spin_unlock_irq(&io_request_lock);
+	
+	/* Apply the mallet of re-education firmly to the drive */
+	ide_do_reset(drive);
+
+	/* At this point the reset state machine is running and
+	   its termination will kick off the next command */	
+	spin_lock_irq(&io_request_lock);
 	return SCSI_RESET_SUCCESS;
+#endif	
 }
 
 int idescsi_bios (Disk *disk, kdev_t dev, int *parm)
